package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataVMapper;
import com.pqs9900.pojo.HisData.DataI;
import com.pqs9900.pojo.HisData.DataV;
import com.pqs9900.service.HisData.DataVService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO 电压相关
 * @Date  2018/12/17 10:54
 **/
@Service
public class DataVServiceImpl implements DataVService {

    private static final Logger logger= LoggerFactory.getLogger(DataVServiceImpl.class);
    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Autowired
    private DataVMapper dataVMapper;
    @Override
    public int saveDataV(DataV dataV) {
        return dataVMapper.insert(dataV);
    }

    @Override
    public int insertDataV(List<DataV> list) {
    	return dataVMapper.insertDataV(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataV 电压相关数据
     */
    @Override
    public Future insertDataVExecutor(List<DataV> listDataV) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataV.size() / (double) inum);
                    List<DataV> tmpListDataV = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataV.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataV.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataV.addAll(listDataV.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataVMapper.insertDataV(tmpListDataV);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("电压相关导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
